
#include "objects.h"
#include "unix.h"
#include "x.h"
#include "xt.h"
#include "externs.h"
#include "resources.h"

XtAppContext app_context;
Widget       toplevel;
char         creatingObject = False;
int          ObjectSelected;
ObjectStruct ObjectValues;
int          numObjects;
String       items[80];
String       filename;

XtActionProc
createOFFObject( w, client_data, call_data )
Widget w;
XtPointer client_data, call_data;
{
    Widget w_form, w_popup, w_top_pane, w_box, list;
    static XtCallbackRec callbacks[] =
    {
        {(XtCallbackProc) NULL, (XtPointer) NULL},
        {(XtCallbackProc) NULL, (XtPointer) NULL},
    };

    Position x, y;

    int i;

    if( creatingObject ) {
        message( toplevel, "Sorry: Creating another object at this time" );
        return;
    }
    creatingObject = True;

    map_dialog(toplevel, &x, &y);
    w_popup = XtVaCreatePopupShell( "Select Object", transientShellWidgetClass,
                                    toplevel,
                                    XtNx, x, XtNy, y,
                                    NULL );

    w_top_pane = XtVaCreateManagedWidget( "w_topPane", panedWidgetClass,
                                          w_popup,
                                          NULL );

    XtVaCreateManagedWidget( "Select Object", labelWidgetClass, w_top_pane,
                             XtNborderWidth, 0,
                             NULL );

    w_box = XtVaCreateManagedWidget( "w_box", boxWidgetClass, w_top_pane,
                                     XtNorientation, XtorientHorizontal,
                                     NULL );

    callbacks[0].callback = (XtCallbackProc) listQuit;
    callbacks[0].closure  = (XtPointer) NULL;
    XtVaCreateManagedWidget( "quit", commandWidgetClass, w_box,
                             XtNcallback, callbacks, NULL );

    /* items = */readObjectsList( w_popup );
    callbacks[0].callback = (XtCallbackProc) selectOFFObject;
    callbacks[0].closure  = (XtPointer) NULL;
    list = XtVaCreateManagedWidget( "list", listWidgetClass, w_box, 
                                    XtNnumberStrings, numObjects,
                                    XtNlist, items,
                                    XtNdefaultColumns, 1,
                                    XtNcallback, callbacks,
                                    NULL );
    XtRealizeWidget( w_popup );
    XtPopup( w_popup, XtGrabNone );
    XMapRaised( XtDisplay( w_popup ), XtWindow( XtParent( w_popup ) ) );
}


void
selectOFFObject( w, closure, call_data )
Widget w;
XtPointer closure, call_data;
{
    XawListReturnStruct *item = (XawListReturnStruct*)call_data;

    ObjectSelected = item->list_index;

    XtUnmanageChild( XtParent( XtParent( XtParent( w ))));
    XtPopdown( XtParent( XtParent( XtParent( w ))));
    XtDestroyWidget( XtParent( XtParent( XtParent( w ))) );

/*  Simple Objects */
         if( !strcmp( item->string, "Box" ) )
        generateBox        ( toplevel );
    else if( !strcmp( item->string, "Cone" ) )
        generateCone       ( toplevel );
    else if( !strcmp( item->string, "Cylinder" ) )
        generateCylinder   ( toplevel );
    else if( !strcmp( item->string, "Sphere" ) )
        generateSphere     ( toplevel );

/*  Super Quadrics */
    else if( !strcmp( item->string, "Ellipsoid" ) )
        generateEllipsoid  ( toplevel );
    else if( !strcmp( item->string, "SuperEllipsoid" ) )
        generateEllipsoid  ( toplevel );
    else if( !strcmp( item->string, "Torus" ) )
        generateTorus      ( toplevel );
    else if( !strcmp( item->string, "SuperTorus" ) )
        generateTorus      ( toplevel );

/*  Functions */
    else if( !strcmp( item->string, "Implicit" ) )
        generateImplicit   ( toplevel );
    else if( !strcmp( item->string, "Parametric" ) )
        generateParametric ( toplevel );

/*  Platonic Solids */
    else if( !strcmp( item->string, "Tetrahedron" ) )
        Tetrahedron        ( );
    else if( !strcmp( item->string, "Cube" ) )
        Cube               ( );
    else if( !strcmp( item->string, "Octahedron" ) )
        Octahedron         ( );
    else if( !strcmp( item->string, "Dodecahedron" ) )
        Dodecahedron       ( );
    else if( !strcmp( item->string, "Icosahedron" ) )
        Icosahedron        ( );

/*  Archimedean Solids */
    else if( !strcmp( item->string, "Cuboctahedron" ) )
        Cuboctahedron      ( );
    else if( !strcmp( item->string, "Icosidodecahedron" ) )
        Icosidodecahedron  ( );
    else if( !strcmp( item->string, "Rhombicosidodecahedron" ) )
        Rhombicosidodecahedron( );
    else if( !strcmp( item->string, "Rhombicuboctahedron" ) )
        Rhombicuboctahedron( );
    else if( !strcmp( item->string, "Rhombitruncated_cubeoctahedron" ) )
        Rhombitruncated_cubeoctahedron( );
    else if( !strcmp( item->string, "Rhombitruncated_icosidodecahedron" ) )
        Rhombitruncated_icosidodecahedron( );
    else if( !strcmp( item->string, "Snub_cube" ) )
        Snub_cube          ( );
    else if( !strcmp( item->string, "Snub_dodecahedron" ) )
        Snub_dodecahedron  ( );
    else if( !strcmp( item->string, "Truncated_cube" ) )
        Truncated_cube     ( );
    else if( !strcmp( item->string, "Truncated_dodecahedron" ) )
        Truncated_dodecahedron( );
    else if( !strcmp( item->string, "Truncated_icosahedron" ) )
        Truncated_icosahedron( );
    else if( !strcmp( item->string, "Truncated_octahedron" ) )
        Truncated_octahedron( );
    else if( !strcmp( item->string, "Truncated_tetrahedron" ) )
        Truncated_tetrahedron( );

/*  Fractals */
    else if( !strcmp( item->string, "Mountains" ) )
        generateMountains  ( toplevel );
}


static void
readObjectsList( w_popup )
Widget w_popup;
{
    int i;
    extern int numObjects;
    FILE *fp;
    char buf[80], *str1;
    char *path;

    if( !getenv( "OBJ_LIST" ) ) {
        fprintf( stderr, "Environment variable OBJ_LIST, undefined\n\n" );
        exit( -1 );
    }

    path = (char *)malloc( strlen( (const char *)getenv("OBJ_LIST") ) + 1 );
    strcpy( path, (const char *)getenv("OBJ_LIST") );
    if( (fp = fopen( path, "r" )) == 0 ) {
        message( w_popup, "Error -- \"ObjectsList\" does not exist" );
        return;
    }
    
    fscanf( fp, "%d\n", &numObjects );
    for( i = 0; i < numObjects; i++ ) {
        fgets( buf, 80, fp );
        buf[strlen(buf)-1] = '\0';
        str1 = (char *) malloc( 80 );
        strcpy( str1, buf );
        items[i] = str1;
    }
    items[i] = NULL;

    fclose( fp );
}


void
listQuit( w, client_data, call_data )
Widget w;
XtPointer client_data, call_data;
{
   XtDestroyWidget( XtParent( XtParent( XtParent( w ) ) ) );
   creatingObject = False;
}


void
finalQuit( w, client_data, call_data )
Widget w;
XtPointer client_data, call_data;
{
   XtDestroyApplicationContext(app_context);
   (void) exit (0);
}
