
#include "objects.h"
#include "unix.h"
#include "x.h"
#include "xt.h"
#include "externs.h"
#include "resources.h"

XtAppContext app_context;
Widget       toplevel;
int          ObjectSelected;
ObjectStruct ObjectValues;
int          numObjects;
String       items[80];
String       filename;

void main( argc, argv )
int argc;
char *argv[];
{
    Widget top_pane, box;
    static XtResource resources[] = { NULL };

    static XtCallbackRec callbacks[] =
    {
        {(XtCallbackProc) NULL, (XtPointer) NULL},
        {(XtCallbackProc) NULL, (XtPointer) NULL},
    };

    if( !getenv( "OBJ_PATH" ) ) {
        fprintf( stderr, "Environment variable OBJ_PATH, undefined\n\n" );
        exit( -1 );
    }

    toplevel = XtAppInitialize( &app_context, "CreateObject",
                                NULL, ZERO,
                                &argc, argv,
                                fallback_resources,
                                NULL, ZERO );

    XtGetApplicationResources( toplevel, (XtPointer) NULL,
                               resources, XtNumber( resources ),
                               NULL, ZERO );

    top_pane = XtVaCreateManagedWidget( "top_pane",
                                        panedWidgetClass, toplevel, NULL );

    XtVaCreateManagedWidget( "Create OFF Object", labelWidgetClass, top_pane, 
                             XtNborderWidth, 0, NULL);

    box = XtVaCreateManagedWidget( "box", boxWidgetClass, top_pane,
                                   XtNorientation, XtorientHorizontal, NULL );

    callbacks[0].callback = (XtCallbackProc) finalQuit;
    callbacks[0].closure  = (XtPointer) NULL;
    XtVaCreateManagedWidget( "quit", commandWidgetClass, box,
                             XtNcallback, callbacks, NULL);

    callbacks[0].callback = (XtCallbackProc) createOFFObject;
    callbacks[0].closure  = (XtPointer) NULL;
    XtVaCreateManagedWidget( "createObj", commandWidgetClass, box,
                             XtNcallback, callbacks, NULL );

    XtRealizeWidget( toplevel );
    XtAppMainLoop( app_context );
}
