
#include "objects.h"
#include "unix.h"
#include "x.h"
#include "xt.h"
#include "externs.h"
#include <sys/time.h>

void readParametricValues();
int checkParametricValues();
extern ObjectStruct ObjectValues;

#define ASCIITEXTATTRIBUTES \
    XtNeditType, XawtextEdit, \
    XtNtype, XawAsciiString, \
    XtNuseStringInPlace, True, \
    XtNresizable, True, \
    XtNresize, XawtextResizeWidth, \
    XtNright, XtChainRight,


typedef struct _Text {
    char *filetext;
    char *textC;
    char *text1, *text2, *text3, *text4, *text5;
} 
Text, *TextPtr;


typedef struct _Pass {
    TextPtr text;
} 
Pass, *PassPtr;


/*
 *   Function Name: getOFFValues
 *   Description: Creates and pops up the Dialog widget to ask for a new
 *                input values
 *   Arguments: w - the command button that activated this function.
 *   Returns: none.
 */

void
generateParametric( toplevel )
Widget toplevel;
{
    TextPtr   text = (TextPtr) malloc( sizeof (Text) );
    PassPtr   pass = (PassPtr) malloc( sizeof (Pass) );

    Widget    g_popup, g_form;
    Widget    g_label0, g_filelabel, g_filetext;
    Widget    g_label1, g_label2, g_label3, g_label4, g_label5;
    Widget    g_text1, g_text2, g_text3, g_text4, g_text5;
    Widget    g_label000, g_label001, g_label002;
    Widget    g_ok, g_cancel;
    Widget    g_title1, g_title2;
    Widget    g_labelC, g_textC;

    Position x, y;

    char   string[20];
    String buffer;

    struct timeval tp;
    struct timezone tzp;

    static XtCallbackRec callbacks[] =
    {
        {(XtCallbackProc) NULL, (XtPointer) NULL},
        {(XtCallbackProc) NULL, (XtPointer) NULL},
    };

    ObjectValues.Obj.Parametric.center.x = 0.0;
    ObjectValues.Obj.Parametric.center.y = 0.0;
    ObjectValues.Obj.Parametric.center.z = 0.0;
    ObjectValues.Obj.Parametric.x_terms = (char *)malloc(5);
    ObjectValues.Obj.Parametric.x_terms = "0";
    ObjectValues.Obj.Parametric.y_terms = (char *)malloc(5);
    ObjectValues.Obj.Parametric.y_terms = "0";
    ObjectValues.Obj.Parametric.z_terms = (char *)malloc(5);
    ObjectValues.Obj.Parametric.z_terms = "0";
    ObjectValues.Obj.Parametric.t_limits = (char *)malloc(15);
    ObjectValues.Obj.Parametric.t_limits = "0.0 < t < 1.0";
    ObjectValues.Obj.Parametric.s_limits = (char *)malloc(15);
    ObjectValues.Obj.Parametric.s_limits = "0.0 < s < 1.0";

    map_dialog(toplevel, &x, &y);
    g_popup = XtVaCreatePopupShell( "Get Values",
        transientShellWidgetClass, toplevel,
        XtNallowShellResize, True,
        XtNx, x, XtNy, y,
        NULL );

    g_form = XtVaCreateManagedWidget( "g_form", formWidgetClass, g_popup,
        NULL );

    sprintf( string, "Object : Parametric" );
    g_label0 = XtVaCreateManagedWidget( "g_label0", labelWidgetClass, g_form,
        XtNlabel, string,
        NULL );

    gettimeofday( &tp, &tzp );
    buffer = (String) malloc( 30 );
    sprintf( buffer, "parametric_%d.geom", (tp.tv_sec)%1000 );
    text->filetext = XtNewString( buffer );
    g_filelabel = XtVaCreateManagedWidget( "g_filelabel", labelWidgetClass,
        g_form,
        XtNfromVert, g_label0,
        NULL );
    g_filetext = XtVaCreateManagedWidget( "g_filetext", asciiTextWidgetClass,
        g_form,
        ASCIITEXTATTRIBUTES
        XtNstring, text->filetext,
        XtNlength, 30,
        XtNwidth, 11*15,
        XtNinsertPosition, strlen(buffer),
        XtNfromVert, g_label0,
        XtNfromHoriz, g_filelabel,
        NULL );

    g_label000 = XtVaCreateManagedWidget( "g_label000", labelWidgetClass,g_form,
        XtNfromVert, g_filelabel,
        NULL );
    g_title1 = XtVaCreateManagedWidget( "g_title1", labelWidgetClass, g_form,
        XtNfromVert, g_label000,
        NULL );

    g_labelC  = XtVaCreateManagedWidget( "g_labelC", labelWidgetClass, g_form,
        XtNwidth, 10*8,
        XtNfromVert, g_title1,
        NULL );

    buffer = (String) malloc( 30 );
    sprintf( buffer, "%.2f %.2f %.2f", ObjectValues.Obj.Parametric.center.x,
       ObjectValues.Obj.Parametric.center.y, ObjectValues.Obj.Parametric.center.z );
    text->textC = XtNewString( buffer );
    g_textC = XtVaCreateManagedWidget( "g_textC", asciiTextWidgetClass,
        g_form,
        ASCIITEXTATTRIBUTES
        XtNstring, text->textC,
        XtNlength, 25,
        XtNwidth, 11*15,
        XtNinsertPosition, strlen(text->textC),
        XtNfromVert, g_title1,
        XtNfromHoriz, g_labelC,
        NULL );

    g_label1 = XtVaCreateManagedWidget( "g_label1", labelWidgetClass, g_form,
        XtNwidth, 10*8,
        XtNfromVert, g_labelC,
        XtNlabel, "x(t,s) =",
        NULL );
    buffer = (String) malloc( 80 );
    strcpy( buffer, ObjectValues.Obj.Parametric.x_terms );
    text->text1 = XtNewString( buffer );
    g_text1  = XtVaCreateManagedWidget( "g_text1", asciiTextWidgetClass, g_form,
        ASCIITEXTATTRIBUTES
        XtNstring, text->text1,
        XtNlength, 80,
        XtNwidth, 11*15,
        XtNinsertPosition, strlen(text->text1),
        XtNfromVert, g_labelC,
        XtNfromHoriz, g_label1,
        NULL );

    g_label2 = XtVaCreateManagedWidget( "g_label2", labelWidgetClass, g_form,
        XtNwidth, 10*8,
        XtNfromVert, g_label1,
        XtNlabel, "y(t,s) =",
        NULL );
    buffer = (String) malloc( 80 );
    strcpy( buffer, ObjectValues.Obj.Parametric.y_terms );
    text->text2 = XtNewString( buffer );
    g_text2  = XtVaCreateManagedWidget( "g_text2", asciiTextWidgetClass, g_form,
        ASCIITEXTATTRIBUTES
        XtNstring, text->text2,
        XtNlength, 80,
        XtNwidth, 11*15,
        XtNinsertPosition, strlen(text->text2),
        XtNfromVert, g_label1,
        XtNfromHoriz, g_label2,
        NULL );

    g_label3 = XtVaCreateManagedWidget( "g_label3", labelWidgetClass, g_form,
        XtNwidth, 10*8,
        XtNfromVert, g_label2,
        XtNlabel, "z(t,s) =",
        NULL );
    buffer = (String) malloc( 80 );
    strcpy( buffer, ObjectValues.Obj.Parametric.z_terms );
    text->text3 = XtNewString( buffer );
    g_text3  = XtVaCreateManagedWidget( "g_text3", asciiTextWidgetClass, g_form,
        ASCIITEXTATTRIBUTES
        XtNstring, text->text3,
        XtNlength, 80,
        XtNwidth, 11*15,
        XtNinsertPosition, strlen(text->text3),
        XtNfromVert, g_label2,
        XtNfromHoriz, g_label3,
        NULL );

    g_label4 = XtVaCreateManagedWidget( "g_label4", labelWidgetClass, g_form,
        XtNwidth, 10*8,
        XtNfromVert, g_label3,
        XtNlabel, "Limits ",
        NULL );
    buffer = (String) malloc( 80 );
    strcpy( buffer, ObjectValues.Obj.Parametric.t_limits );
    text->text4 = XtNewString( buffer );
    g_text4  = XtVaCreateManagedWidget( "g_text4", asciiTextWidgetClass, g_form,
        ASCIITEXTATTRIBUTES
        XtNstring, text->text4,
        XtNlength, 80,
        XtNwidth, 11*15,
        XtNinsertPosition, strlen(text->text4),
        XtNfromVert, g_label3,
        XtNfromHoriz, g_label4,
        NULL );

    g_label5 = XtVaCreateManagedWidget( "g_label5", labelWidgetClass, g_form,
        XtNwidth, 10*8,
        XtNfromVert, g_label4,
        XtNlabel, "Limits ",
        NULL );
    buffer = (String) malloc( 80 );
    strcpy( buffer, ObjectValues.Obj.Parametric.s_limits );
    text->text5 = XtNewString( buffer );
    g_text5  = XtVaCreateManagedWidget( "g_text5", asciiTextWidgetClass, g_form,
        ASCIITEXTATTRIBUTES
        XtNstring, text->text5,
        XtNlength, 80,
        XtNwidth, 11*15,
        XtNinsertPosition, strlen(text->text5),
        XtNfromVert, g_label4,
        XtNfromHoriz, g_label5,
        NULL );

    pass->text = text;

    callbacks[0].callback = (XtCallbackProc) readParametricValues;
    callbacks[0].closure  = (XtPointer) text;
    g_ok = XtVaCreateManagedWidget( "g_ok", commandWidgetClass, g_form,
        XtNcallback, callbacks,
        XtNfromVert, g_label5,
        XtNvertDistance, 20,
        NULL );

    callbacks[0].callback = (XtCallbackProc) DestroyPopupPrompt;
    callbacks[0].closure  = (XtPointer) g_popup;
    g_cancel = XtVaCreateManagedWidget( "g_cancel", commandWidgetClass, g_form,
        XtNcallback, callbacks,
        XtNfromVert, g_label5,
        XtNfromHoriz, g_ok,
        XtNvertDistance, 20,
        NULL );

/*
    XtRealizeWidget( g_popup );
*/
    XtPopup( g_popup, XtGrabNone );
    XMapRaised( XtDisplay( g_popup ), XtWindow( XtParent( g_popup ) ) );
}


static void
DestroyPopupPrompt( widget, client_data, call_data )
Widget widget;
XtPointer call_data, client_data;
{
    Widget popup = (Widget)client_data;
    extern char creatingObject;
    creatingObject = False;
    XtPopdown( popup );
    XtDestroyWidget( popup );
}


void
readParametricValues( widget, client_data, call_data )
Widget widget;
XtPointer client_data, call_data;
{
    Widget popup = XtParent( XtParent( widget ) );
    TextPtr ptext = (TextPtr) client_data;
    extern char creatingObject;

    Point center;
    char * x, * y, * z, * t, * s;
    Status status;
    int primitive=0;

    extern String filename;

    filename = (String) malloc( strlen((const char *)getenv("OBJ_PATH")) + 80 );

    strcat( strcat( strcpy( filename, (const char *)getenv("OBJ_PATH") ), "/" ), ptext->filetext );
    sscanf( ptext->textC, "%f %f %f", &(center.x), &(center.y), &(center.z) );
    XtFree( ptext->textC );
    x = (char *)malloc( strlen( ptext->text1 ) + 1 );
    strcpy( x, ptext->text1 );
    XtFree( ptext->text1 );
    y = (char *)malloc( strlen( ptext->text2 ) + 1 );
    strcpy( y, ptext->text2 );
    XtFree( ptext->text2 );
    z = (char *)malloc( strlen( ptext->text3 ) + 1 );
    strcpy( z, ptext->text3 );
    XtFree( ptext->text3 );
    t = (char *)malloc( strlen( ptext->text4 ) + 1 );
    strcpy( t, ptext->text4 );
    XtFree( ptext->text4 );
    s = (char *)malloc( strlen( ptext->text5 ) + 1 );
    strcpy( s, ptext->text5 );
    XtFree( ptext->text5 );

    ObjectValues.Obj.Parametric.center.x = center.x;
    ObjectValues.Obj.Parametric.center.y = center.y;
    ObjectValues.Obj.Parametric.center.z = center.z;
    ObjectValues.Obj.Parametric.x_terms = (char *)malloc( strlen( x ) + 1 );
    strcpy( ObjectValues.Obj.Parametric.x_terms, x );
    ObjectValues.Obj.Parametric.y_terms = (char *)malloc( strlen( y ) + 1 );
    strcpy( ObjectValues.Obj.Parametric.y_terms, y );
    ObjectValues.Obj.Parametric.z_terms = (char *)malloc( strlen( z ) + 1 );
    strcpy( ObjectValues.Obj.Parametric.z_terms, z );
    ObjectValues.Obj.Parametric.t_limits = (char *)malloc( strlen( t ) + 1 );
    strcpy( ObjectValues.Obj.Parametric.t_limits, t );
    ObjectValues.Obj.Parametric.s_limits = (char *)malloc( strlen( s ) + 1 );
    strcpy( ObjectValues.Obj.Parametric.s_limits, s );

    if( !(status = checkParametricValues( popup, x, y, z, t, s, center ) ) )
        message( popup, "SORRY -- Not Implemented Yet" );
/*      ParametricFunction( x, y, z, t, s, center ); */

    creatingObject = False;
    XtPopdown( popup );
    XtDestroyWidget( popup );
}


int
checkParametricValues( w, x_terms, y_terms, z_terms, t_limits, s_limits, center )
Widget w;
char * x_terms, * y_terms, * z_terms, * t_limits, * s_limits;
Point center;
{
    int errors = 0;

    return errors;
}
