
#include <stdio.h>
#include "x.h"
#include "xt.h"
#include "xpex.h"
#include "color.h"

#define DEGRAD( _a )  ( ( float )( _a ) * 3.1415926 / 180.0 )
#define RADDEG( _a )  ( ( float )( _a ) * 180.0 / 3.1415926 )

extern Widget      cieColor;
extern Widget      mixedColor;

extern Display    *display;
extern Window      mixed_window;
extern Window      window;
extern Window      red_window;
extern Window      green_window;
extern Window      blue_window;
extern Pixmap      pixmap;
extern Pixmap      red_pixmap;
extern Pixmap      green_pixmap;
extern Pixmap      blue_pixmap;
extern GC          gc;
extern Colormap    colormap;
extern int         depth;

PEXRenderer        rd;
PEXPipelineContext pc;
PEXStructure       sid;
XID                resource_id;
PEXOCRequestType   dest;

extern PEXRenderer           mixed_rd;
       unsigned long         mixed_rdMask;
extern PEXRendererAttributes mixed_rdVals;


void createCIEWindow( w, client_data, call_data )
Widget w;
XtPointer client_data, call_data;
{
    int xpos = 100;
    int ypos = 600;
    XSetWindowAttributes  WVals;

    char *string;
    XPoint pnt[25];
    XSegment seg[10];

    unsigned long         rdMask = 0;
    PEXRendererAttributes rdVals;

    unsigned long         pcMask[3];
    PEXPCAttributes       pcVals;

    PEXColorSpecifier     colorEnt[24];
    PEXLookupTable        colorLUT;

    extern PEXColorApproxEntry   approxEnt;
    PEXLookupTable        colorApproxLUT;

#include "pointsData.ci"
#include "points.ci"

    static float xaxis[] = { 0.0, 0.9, 1.0, 0.9 };
    static float xtick8[] = { 0.8, 0.875, 0.8, 0.925 };
    static float xtick7[] = { 0.7, 0.875, 0.7, 0.925 };
    static float xtick6[] = { 0.6, 0.875, 0.6, 0.925 };
    static float xtick5[] = { 0.5, 0.875, 0.5, 0.925 };
    static float xtick4[] = { 0.4, 0.875, 0.4, 0.925 };
    static float xtick3[] = { 0.3, 0.875, 0.3, 0.925 };
    static float xtick2[] = { 0.2, 0.875, 0.2, 0.925 };
    static float xtick1[] = { 0.1, 0.875, 0.1, 0.925 };

    static float yaxis[] = { 0.9, 0.0, 0.9, 1.0 };
    static float ytick8[] = { 0.875, 0.8, 0.925, 0.8 };
    static float ytick7[] = { 0.875, 0.7, 0.925, 0.7 };
    static float ytick6[] = { 0.875, 0.6, 0.925, 0.6 };
    static float ytick5[] = { 0.875, 0.5, 0.925, 0.5 };
    static float ytick4[] = { 0.875, 0.4, 0.925, 0.4 };
    static float ytick3[] = { 0.875, 0.3, 0.925, 0.3 };
    static float ytick2[] = { 0.875, 0.2, 0.925, 0.2 };
    static float ytick1[] = { 0.875, 0.1, 0.925, 0.1 };

    static float monitor[] = {
        0.155, 0.08,
        0.28, 0.58,
        0.62, 0.35,
        0.155, 0.08
    };

    PEXListOfVertex pointList[6];

#include "color.ci"

    window = XtWindow( cieColor );
    mixed_window = XtWindow( mixedColor );

    WVals.background_pixel = 0;
    WVals.border_pixel = 0;
    WVals.colormap = colormap;
    WVals.backing_store = NotUseful;
    XChangeWindowAttributes( display, window,
        CWBackingStore | CWBackPixel | CWBorderPixel | CWColormap, &WVals );

    if( depth == 8 ) {
        gc = XCreateGC( display, window, 0, 0 );
        pixmap = XCreatePixmap( display, window, 200, 200, 8 );
        XSetForeground( display, gc, AllocColor( display, colormap, "black" ) );
        XFillRectangle( display, pixmap, gc, 0, 0, 200, 200 );
    }

    if( depth == 8 ) {
        int i, width = 21, height = 200, step, delta = 21; /* 20 + 1 */
        extern Widget redScroll, greenScroll, blueScroll;

        string = (char *) malloc(20);
        step = height / (delta-1);
        red_window = XtWindow( redScroll );
        red_pixmap = XCreatePixmap( display, red_window, width, height, depth );
        green_window = XtWindow( greenScroll );
        green_pixmap = XCreatePixmap( display,green_window,width,height,depth );
        blue_window = XtWindow( blueScroll );
        blue_pixmap = XCreatePixmap( display, blue_window, width,height,depth );

        for( i=1; i< delta; i++ ) {
            sprintf( string, "#%x0000", (delta-i) * 255 / (delta-1) );
            if( i == (delta-1) ) sprintf( string, "#0c0000" );
            XSetForeground( display, gc, AllocColor( display,colormap,string ));
            pnt[0].x = 0;        pnt[0].y = (i-1) * step;
            pnt[1].x = width;    pnt[1].y = (i-1) * step;
            pnt[2].x = width;    pnt[2].y = i * step;
            pnt[3].x = 0;        pnt[3].y = i * step;
            XFillPolygon( display,red_pixmap,gc,pnt,4,Convex,CoordModeOrigin );
        }
        for( i=1; i< delta; i++ ) {
            sprintf( string, "#00%x00", (delta-i) * 255 / (delta-1) );
            if( i == (delta-1) ) sprintf( string, "#000c00" );
            XSetForeground( display, gc, AllocColor( display,colormap,string ));
            pnt[0].x = 0;        pnt[0].y = (i-1) * step;
            pnt[1].x = width;    pnt[1].y = (i-1) * step;
            pnt[2].x = width;    pnt[2].y = i * step;
            pnt[3].x = 0;        pnt[3].y = i * step;
            XFillPolygon( display,green_pixmap,gc,pnt,4,Convex,CoordModeOrigin);
        }
        for( i=1; i< delta; i++ ) {
            sprintf( string, "#0000%x", (delta-i) * 255 / (delta-1) );
            if( i == (delta-1) ) sprintf( string, "#00000c" );
            XSetForeground( display, gc, AllocColor( display,colormap,string ));
            pnt[0].x = 0;        pnt[0].y = (i-1) * step;
            pnt[1].x = width;    pnt[1].y = (i-1) * step;
            pnt[2].x = width;    pnt[2].y = i * step;
            pnt[3].x = 0;        pnt[3].y = i * step;
            XFillPolygon( display,blue_pixmap,gc,pnt,4,Convex,CoordModeOrigin );
        }

        XtVaSetValues( redScroll, XtNbackgroundPixmap, red_pixmap, NULL );
        XtVaSetValues( greenScroll, XtNbackgroundPixmap, green_pixmap, NULL );
        XtVaSetValues( blueScroll, XtNbackgroundPixmap, blue_pixmap, NULL );
    }

    /* Create a renderer */
    rdVals.clear_image = True;
    rdMask |= PEXRAClearImage;
    rdVals.clear_z = True;
    rdMask |= PEXRAClearZ;
    rdVals.background_color.type = PEXColorTypeRGB;
    rdVals.background_color.value.rgb.red = 0.0;
    rdVals.background_color.value.rgb.green = 0.0;
    rdVals.background_color.value.rgb.blue = 0.0;
    rdMask |= PEXRABackgroundColor;

    if( depth != 8 ) {
        /* Create Color lookup table */
        colorLUT = PEXCreateLookupTable( display, window, PEXLUTColor );
        PEXSetTableEntries( display, colorLUT, 1, 24, PEXLUTColor,
            (PEXPointer)colorEnt );

        /* Create Color Approx lookup table */
        colorApproxLUT = PEXCreateLookupTable( display, window,
            PEXLUTColorApprox );
        PEXSetTableEntries( display, colorApproxLUT, 0, 1,
            PEXLUTColorApprox, (PEXPointer)&approxEnt );

        rdVals.color_table = colorLUT;
        rdMask |= PEXRAColorTable;
        rdVals.color_approx_table = colorApproxLUT;
        rdMask |= PEXRAColorApproxTable;
    }

    rd = PEXCreateRenderer( display, window, rdMask, &rdVals );

    /* Create a renderer */
    mixed_rdVals.clear_image = True;
    mixed_rdMask |= PEXRAClearImage;
    mixed_rdVals.background_color.type = PEXColorTypeRGB;
    mixed_rdVals.background_color.value.rgb.red = 0.0;
    mixed_rdVals.background_color.value.rgb.green = 0.0;
    mixed_rdVals.background_color.value.rgb.blue = 0.0;
    mixed_rdMask |= PEXRABackgroundColor;
    if( depth != 8 ) {
        mixed_rdVals.color_approx_table = colorApproxLUT;
        mixed_rdMask |= PEXRAColorApproxTable;
    }

    mixed_rd = PEXCreateRenderer( display, mixed_window,
        mixed_rdMask, &mixed_rdVals );

    sid = PEXCreateStructure( display );
    resource_id = ( XID )sid;
    dest = PEXOCStore;

    if( depth == 8 ) {
        string = (char *) malloc(20);

        seg[0].x1 = xaxis[0] * 200;  seg[0].y1 = 200 - xaxis[1] * 200;
        seg[0].x2 = xaxis[2] * 200;  seg[0].y2 = 200 - xaxis[3] * 200;
        seg[1].x1 = xtick8[0] * 200; seg[1].y1 = 200 - xtick8[1] * 200;
        seg[1].x2 = xtick8[2] * 200; seg[1].y2 = 200 - xtick8[3] * 200;
        seg[2].x1 = xtick7[0] * 200; seg[2].y1 = 200 - xtick7[1] * 200;
        seg[2].x2 = xtick7[2] * 200; seg[2].y2 = 200 - xtick7[3] * 200;
        seg[3].x1 = xtick6[0] * 200; seg[3].y1 = 200 - xtick6[1] * 200;
        seg[3].x2 = xtick6[2] * 200; seg[3].y2 = 200 - xtick6[3] * 200;
        seg[4].x1 = xtick5[0] * 200; seg[4].y1 = 200 - xtick5[1] * 200;
        seg[4].x2 = xtick5[2] * 200; seg[4].y2 = 200 - xtick5[3] * 200;
        seg[5].x1 = xtick4[0] * 200; seg[5].y1 = 200 - xtick4[1] * 200;
        seg[5].x2 = xtick4[2] * 200; seg[5].y2 = 200 - xtick4[3] * 200;
        seg[6].x1 = xtick3[0] * 200; seg[6].y1 = 200 - xtick3[1] * 200;
        seg[6].x2 = xtick3[2] * 200; seg[6].y2 = 200 - xtick3[3] * 200;
        seg[7].x1 = xtick2[0] * 200; seg[7].y1 = 200 - xtick2[1] * 200;
        seg[7].x2 = xtick2[2] * 200; seg[7].y2 = 200 - xtick2[3] * 200;
        seg[8].x1 = xtick1[0] * 200; seg[8].y1 = 200 - xtick1[1] * 200;
        seg[8].x2 = xtick1[2] * 200; seg[8].y2 = 200 - xtick1[3] * 200;
        XSetForeground( display, gc, AllocColor( display, colormap, "white" ) );
        XDrawSegments( display, pixmap, gc, seg, 9 );

        seg[0].x1 = yaxis[0] * 200;  seg[0].y1 = 200 - yaxis[1] * 200;
        seg[0].x2 = yaxis[2] * 200;  seg[0].y2 = 200 - yaxis[3] * 200;
        seg[1].x1 = ytick8[0] * 200; seg[1].y1 = 200 - ytick8[1] * 200;
        seg[1].x2 = ytick8[2] * 200; seg[1].y2 = 200 - ytick8[3] * 200;
        seg[2].x1 = ytick7[0] * 200; seg[2].y1 = 200 - ytick7[1] * 200;
        seg[2].x2 = ytick7[2] * 200; seg[2].y2 = 200 - ytick7[3] * 200;
        seg[3].x1 = ytick6[0] * 200; seg[3].y1 = 200 - ytick6[1] * 200;
        seg[3].x2 = ytick6[2] * 200; seg[3].y2 = 200 - ytick6[3] * 200;
        seg[4].x1 = ytick5[0] * 200; seg[4].y1 = 200 - ytick5[1] * 200;
        seg[4].x2 = ytick5[2] * 200; seg[4].y2 = 200 - ytick5[3] * 200;
        seg[5].x1 = ytick4[0] * 200; seg[5].y1 = 200 - ytick4[1] * 200;
        seg[5].x2 = ytick4[2] * 200; seg[5].y2 = 200 - ytick4[3] * 200;
        seg[6].x1 = ytick3[0] * 200; seg[6].y1 = 200 - ytick3[1] * 200;
        seg[6].x2 = ytick3[2] * 200; seg[6].y2 = 200 - ytick3[3] * 200;
        seg[7].x1 = ytick2[0] * 200; seg[7].y1 = 200 - ytick2[1] * 200;
        seg[7].x2 = ytick2[2] * 200; seg[7].y2 = 200 - ytick2[3] * 200;
        seg[8].x1 = ytick1[0] * 200; seg[8].y1 = 200 - ytick1[1] * 200;
        seg[8].x2 = ytick1[2] * 200; seg[8].y2 = 200 - ytick1[3] * 200;
        XSetForeground( display, gc, AllocColor( display, colormap, "white" ) );
        XDrawSegments( display, pixmap, gc, seg, 9 );

        sprintf( string, "#%x00%x", (int)(colorEnt[1].value.rgb.red*255),

                                    (int)(colorEnt[1].value.rgb.blue*255));
        XSetForeground( display, gc, AllocColor( display, colormap, string ) );
        pnt[0].x = points1[0] * 200; pnt[0].y = 200 - points1[1] * 200;
        pnt[1].x = points1[2] * 200; pnt[1].y = 200 - points1[3] * 200;
        pnt[2].x = points1[4] * 200; pnt[2].y = 200 - points1[5] * 200;
        pnt[3].x = points1[6] * 200; pnt[3].y = 200 - points1[7] * 200;
        XFillPolygon( display, pixmap, gc, pnt, 4, Convex, CoordModeOrigin );

        sprintf( string, "#%x00%x", (int)(colorEnt[2].value.rgb.red*255),

                                    (int)(colorEnt[2].value.rgb.blue*255));
        XSetForeground( display, gc, AllocColor( display, colormap, string ) );
        pnt[0].x = points2[0] * 200; pnt[0].y = 200 - points2[1] * 200;
        pnt[1].x = points2[2] * 200; pnt[1].y = 200 - points2[3] * 200;
        pnt[2].x = points2[4] * 200; pnt[2].y = 200 - points2[5] * 200;
        pnt[3].x = points2[6] * 200; pnt[3].y = 200 - points2[7] * 200;
        XFillPolygon( display, pixmap, gc, pnt, 4, Convex, CoordModeOrigin );

        sprintf( string, "#%x01%x", (int)(colorEnt[3].value.rgb.red*255),

                                    (int)(colorEnt[3].value.rgb.blue*255));
        XSetForeground( display, gc, AllocColor( display, colormap, string ) );
        pnt[0].x = points3[0] * 200; pnt[0].y = 200 - points3[1] * 200;
        pnt[1].x = points3[2] * 200; pnt[1].y = 200 - points3[3] * 200;
        pnt[2].x = points3[4] * 200; pnt[2].y = 200 - points3[5] * 200;
        pnt[3].x = points3[6] * 200; pnt[3].y = 200 - points3[7] * 200;
        XFillPolygon( display, pixmap, gc, pnt, 4, Convex, CoordModeOrigin );

        sprintf( string, "#%x0a%x", (int)(colorEnt[4].value.rgb.red*255),

                                    (int)(colorEnt[4].value.rgb.blue*255));
        XSetForeground( display, gc, AllocColor( display, colormap, string ) );
        pnt[0].x = points4[0] * 200; pnt[0].y = 200 - points4[1] * 200;
        pnt[1].x = points4[2] * 200; pnt[1].y = 200 - points4[3] * 200;
        pnt[2].x = points4[4] * 200; pnt[2].y = 200 - points4[5] * 200;
        pnt[3].x = points4[6] * 200; pnt[3].y = 200 - points4[7] * 200;
        XFillPolygon( display, pixmap, gc, pnt, 4, Convex, CoordModeOrigin );

        sprintf( string, "#0b%x%x", 
                                    (int)(colorEnt[5].value.rgb.green*255),
                                    (int)(colorEnt[5].value.rgb.blue*255));
        XSetForeground( display, gc, AllocColor( display, colormap, string ) );
        pnt[0].x = points5[0] * 200; pnt[0].y = 200 - points5[1] * 200;
        pnt[1].x = points5[2] * 200; pnt[1].y = 200 - points5[3] * 200;
        pnt[2].x = points5[4] * 200; pnt[2].y = 200 - points5[5] * 200;
        pnt[3].x = points5[6] * 200; pnt[3].y = 200 - points5[7] * 200;
        XFillPolygon( display, pixmap, gc, pnt, 4, Convex, CoordModeOrigin );

        sprintf( string, "#00%x%x",
                                    (int)(colorEnt[6].value.rgb.green*255),
                                    (int)(colorEnt[6].value.rgb.blue*255));
        XSetForeground( display, gc, AllocColor( display, colormap, string ) );
        pnt[0].x = points6[0] * 200; pnt[0].y = 200 - points6[1] * 200;
        pnt[1].x = points6[2] * 200; pnt[1].y = 200 - points6[3] * 200;
        pnt[2].x = points6[4] * 200; pnt[2].y = 200 - points6[5] * 200;
        pnt[3].x = points6[6] * 200; pnt[3].y = 200 - points6[7] * 200;
        XFillPolygon( display, pixmap, gc, pnt, 4, Convex, CoordModeOrigin );

        sprintf( string, "#00%x%x",
                                    (int)(colorEnt[7].value.rgb.green*255),
                                    (int)(colorEnt[7].value.rgb.blue*255));
        XSetForeground( display, gc, AllocColor( display, colormap, string ) );
        pnt[0].x = points7[0] * 200; pnt[0].y = 200 - points7[1] * 200;
        pnt[1].x = points7[2] * 200; pnt[1].y = 200 - points7[3] * 200;
        pnt[2].x = points7[4] * 200; pnt[2].y = 200 - points7[5] * 200;
        pnt[3].x = points7[6] * 200; pnt[3].y = 200 - points7[7] * 200;
        XFillPolygon( display, pixmap, gc, pnt, 4, Convex, CoordModeOrigin );

        sprintf( string, "#00%x%x",
                                    (int)(colorEnt[8].value.rgb.green*255),
                                    (int)(colorEnt[8].value.rgb.blue*255));
        XSetForeground( display, gc, AllocColor( display, colormap, string ) );
        pnt[0].x = points8[0] * 200; pnt[0].y = 200 - points8[1] * 200;
        pnt[1].x = points8[2] * 200; pnt[1].y = 200 - points8[3] * 200;
        pnt[2].x = points8[4] * 200; pnt[2].y = 200 - points8[5] * 200;
        pnt[3].x = points8[6] * 200; pnt[3].y = 200 - points8[7] * 200;
        XFillPolygon( display, pixmap, gc, pnt, 4, Convex, CoordModeOrigin );

        sprintf( string, "#00%x%x",
                                    (int)(colorEnt[9].value.rgb.green*255),
                                    (int)(colorEnt[9].value.rgb.blue*255));
        XSetForeground( display, gc, AllocColor( display, colormap, string ) );
        pnt[0].x = points9[0] * 200; pnt[0].y = 200 - points9[1] * 200;
        pnt[1].x = points9[2] * 200; pnt[1].y = 200 - points9[3] * 200;
        pnt[2].x = points9[4] * 200; pnt[2].y = 200 - points9[5] * 200;
        pnt[3].x = points9[6] * 200; pnt[3].y = 200 - points9[7] * 200;
        pnt[4].x = points9[8] * 200; pnt[4].y = 200 - points9[9] * 200;
        pnt[5].x = points9[10] * 200; pnt[5].y = 200 - points9[11] * 200;
        pnt[6].x = points9[12] * 200; pnt[6].y = 200 - points9[13] * 200;
        pnt[7].x = points9[14] * 200; pnt[7].y = 200 - points9[15] * 200;
        pnt[8].x = points9[16] * 200; pnt[8].y = 200 - points9[17] * 200;
        pnt[9].x = points9[18] * 200; pnt[9].y = 200 - points9[19] * 200;
        XFillPolygon( display, pixmap, gc, pnt, 10, Convex, CoordModeOrigin );

        sprintf( string, "#00%x00",
                                    (int)(colorEnt[10].value.rgb.green*255));
                                    
        XSetForeground( display, gc, AllocColor( display, colormap, string ) );
        pnt[0].x = points10[0] * 200; pnt[0].y = 200 - points10[1] * 200;
        pnt[1].x = points10[2] * 200; pnt[1].y = 200 - points10[3] * 200;
        pnt[2].x = points10[4] * 200; pnt[2].y = 200 - points10[5] * 200;
        pnt[3].x = points10[6] * 200; pnt[3].y = 200 - points10[7] * 200;
        XFillPolygon( display, pixmap, gc, pnt, 4, Convex, CoordModeOrigin );

        sprintf( string, "#%x%x00", (int)(colorEnt[11].value.rgb.red*255),
                                    (int)(colorEnt[11].value.rgb.green*255));
                                    
        XSetForeground( display, gc, AllocColor( display, colormap, string ) );
        pnt[0].x = points11[0] * 200; pnt[0].y = 200 - points11[1] * 200;
        pnt[1].x = points11[2] * 200; pnt[1].y = 200 - points11[3] * 200;
        pnt[2].x = points11[4] * 200; pnt[2].y = 200 - points11[5] * 200;
        pnt[3].x = points11[6] * 200; pnt[3].y = 200 - points11[7] * 200;
        XFillPolygon( display, pixmap, gc, pnt, 4, Convex, CoordModeOrigin );

        sprintf( string, "#%x%x00", (int)(colorEnt[12].value.rgb.red*255),
                                    (int)(colorEnt[12].value.rgb.green*255));
                                    
        XSetForeground( display, gc, AllocColor( display, colormap, string ) );
        pnt[0].x = points12[0] * 200; pnt[0].y = 200 - points12[1] * 200;
        pnt[1].x = points12[2] * 200; pnt[1].y = 200 - points12[3] * 200;
        pnt[2].x = points12[4] * 200; pnt[2].y = 200 - points12[5] * 200;
        pnt[3].x = points12[6] * 200; pnt[3].y = 200 - points12[7] * 200;
        XFillPolygon( display, pixmap, gc, pnt, 4, Convex, CoordModeOrigin );

        sprintf( string, "#%x%x00", (int)(colorEnt[13].value.rgb.red*255),
                                    (int)(colorEnt[13].value.rgb.green*255));

        XSetForeground( display, gc, AllocColor( display, colormap, string ) );
        pnt[0].x = points13[0] * 200; pnt[0].y = 200 - points13[1] * 200;
        pnt[1].x = points13[2] * 200; pnt[1].y = 200 - points13[3] * 200;
        pnt[2].x = points13[4] * 200; pnt[2].y = 200 - points13[5] * 200;
        pnt[3].x = points13[6] * 200; pnt[3].y = 200 - points13[7] * 200;
        XFillPolygon( display, pixmap, gc, pnt, 4, Convex, CoordModeOrigin );

        sprintf( string, "#%x%x00", (int)(colorEnt[14].value.rgb.red*255),
                                    (int)(colorEnt[14].value.rgb.green*255));

        XSetForeground( display, gc, AllocColor( display, colormap, string ) );
        pnt[0].x = points14[0] * 200; pnt[0].y = 200 - points14[1] * 200;
        pnt[1].x = points14[2] * 200; pnt[1].y = 200 - points14[3] * 200;
        pnt[2].x = points14[4] * 200; pnt[2].y = 200 - points14[5] * 200;
        pnt[3].x = points14[6] * 200; pnt[3].y = 200 - points14[7] * 200;
        XFillPolygon( display, pixmap, gc, pnt, 4, Convex, CoordModeOrigin );

        sprintf( string, "#%x%x00", (int)(colorEnt[15].value.rgb.red*255),
                                    (int)(colorEnt[15].value.rgb.green*255));

        XSetForeground( display, gc, AllocColor( display, colormap, string ) );
        pnt[0].x = points15[0] * 200; pnt[0].y = 200 - points15[1] * 200;
        pnt[1].x = points15[2] * 200; pnt[1].y = 200 - points15[3] * 200;
        pnt[2].x = points15[4] * 200; pnt[2].y = 200 - points15[5] * 200;
        pnt[3].x = points15[6] * 200; pnt[3].y = 200 - points15[7] * 200;
        pnt[4].x = points15[8] * 200; pnt[4].y = 200 - points15[9] * 200;
        pnt[5].x = points15[10] * 200; pnt[5].y = 200 - points15[11] * 200;
        XFillPolygon( display, pixmap, gc, pnt, 6, Complex, CoordModeOrigin );

        sprintf( string, "#%x0e00", (int)(colorEnt[16].value.rgb.red*255));
                                    
                                    
        XSetForeground( display, gc, AllocColor( display, colormap, string ) );
        pnt[0].x = points16[0] * 200; pnt[0].y = 200 - points16[1] * 200;
        pnt[1].x = points16[2] * 200; pnt[1].y = 200 - points16[3] * 200;
        pnt[2].x = points16[4] * 200; pnt[2].y = 200 - points16[5] * 200;
        pnt[3].x = points16[6] * 200; pnt[3].y = 200 - points16[7] * 200;
        XFillPolygon( display, pixmap, gc, pnt, 4, Convex, CoordModeOrigin );

        sprintf( string, "#%x000c", (int)(colorEnt[17].value.rgb.red*255));
                                
                                    
        XSetForeground( display, gc, AllocColor( display, colormap, string ) );
        pnt[0].x = points17[0] * 200; pnt[0].y = 200 - points17[1] * 200;
        pnt[1].x = points17[2] * 200; pnt[1].y = 200 - points17[3] * 200;
        pnt[2].x = points17[4] * 200; pnt[2].y = 200 - points17[5] * 200;
        pnt[3].x = points17[6] * 200; pnt[3].y = 200 - points17[7] * 200;
        pnt[4].x = points17[8] * 200; pnt[4].y = 200 - points17[9] * 200;
        XFillPolygon( display, pixmap, gc, pnt, 5, Convex, CoordModeOrigin );

        sprintf( string, "#%x00%x", (int)(colorEnt[18].value.rgb.red*255),

                                    (int)(colorEnt[18].value.rgb.blue*255));
        XSetForeground( display, gc, AllocColor( display, colormap, string ) );
        pnt[0].x = points18[0] * 200; pnt[0].y = 200 - points18[1] * 200;
        pnt[1].x = points18[2] * 200; pnt[1].y = 200 - points18[3] * 200;
        pnt[2].x = points18[4] * 200; pnt[2].y = 200 - points18[5] * 200;
        pnt[3].x = points18[6] * 200; pnt[3].y = 200 - points18[7] * 200;
        XFillPolygon( display, pixmap, gc, pnt, 4, Convex, CoordModeOrigin );

        sprintf( string, "#%x00%x", (int)(colorEnt[19].value.rgb.red*255),

                                    (int)(colorEnt[19].value.rgb.blue*255));
        XSetForeground( display, gc, AllocColor( display, colormap, string ) );
        pnt[0].x = points19[0] * 200; pnt[0].y = 200 - points19[1] * 200;
        pnt[1].x = points19[2] * 200; pnt[1].y = 200 - points19[3] * 200;
        pnt[2].x = points19[4] * 200; pnt[2].y = 200 - points19[5] * 200;
        pnt[3].x = points19[6] * 200; pnt[3].y = 200 - points19[7] * 200;
        XFillPolygon( display, pixmap, gc, pnt, 4, Convex, CoordModeOrigin );

        sprintf( string, "#%x%x%x", (int)(colorEnt[20].value.rgb.red*255),
                                    (int)(colorEnt[20].value.rgb.green*255),
                                    (int)(colorEnt[20].value.rgb.blue*255));
        XSetForeground( display, gc, AllocColor( display, colormap, string ) );
        pnt[0].x = points20[0] * 200; pnt[0].y = 200 - points20[1] * 200;
        pnt[1].x = points20[2] * 200; pnt[1].y = 200 - points20[3] * 200;
        pnt[2].x = points20[4] * 200; pnt[2].y = 200 - points20[5] * 200;
        pnt[3].x = points20[6] * 200; pnt[3].y = 200 - points20[7] * 200;
        XFillPolygon( display, pixmap, gc, pnt, 4, Convex, CoordModeOrigin );

        sprintf( string, "#%x%x%x", (int)(colorEnt[21].value.rgb.red*255),
                                    (int)(colorEnt[21].value.rgb.green*255),
                                    (int)(colorEnt[21].value.rgb.blue*255));
        XSetForeground( display, gc, AllocColor( display, colormap, string ) );
        pnt[0].x = points21[0] * 200; pnt[0].y = 200 - points21[1] * 200;
        pnt[1].x = points21[2] * 200; pnt[1].y = 200 - points21[3] * 200;
        pnt[2].x = points21[4] * 200; pnt[2].y = 200 - points21[5] * 200;
        pnt[3].x = points21[6] * 200; pnt[3].y = 200 - points21[7] * 200;
        XFillPolygon( display, pixmap, gc, pnt, 4, Convex, CoordModeOrigin );

        sprintf( string, "#%x%x%x", (int)(colorEnt[22].value.rgb.red*255),
                                    (int)(colorEnt[22].value.rgb.green*255),
                                    (int)(colorEnt[22].value.rgb.blue*255));
        XSetForeground( display, gc, AllocColor( display, colormap, string ) );
        pnt[0].x = points22[0] * 200; pnt[0].y = 200 - points22[1] * 200;
        pnt[1].x = points22[2] * 200; pnt[1].y = 200 - points22[3] * 200;
        pnt[2].x = points22[4] * 200; pnt[2].y = 200 - points22[5] * 200;
        pnt[3].x = points22[6] * 200; pnt[3].y = 200 - points22[7] * 200;
        XFillPolygon( display, pixmap, gc, pnt, 4, Convex, CoordModeOrigin );

        sprintf( string, "#%x%x%x", (int)(colorEnt[23].value.rgb.red*255),
                                    (int)(colorEnt[23].value.rgb.green*255),
                                    (int)(colorEnt[23].value.rgb.blue*255));
        XSetForeground( display, gc, AllocColor( display, colormap, string ) );
        pnt[0].x = points23[0] * 200; pnt[0].y = 200 - points23[1] * 200;
        pnt[1].x = points23[2] * 200; pnt[1].y = 200 - points23[3] * 200;
        pnt[2].x = points23[4] * 200; pnt[2].y = 200 - points23[5] * 200;
        pnt[3].x = points23[6] * 200; pnt[3].y = 200 - points23[7] * 200;
        pnt[4].x = points23[8] * 200; pnt[4].y = 200 - points23[9] * 200;
        pnt[5].x = points23[10] * 200; pnt[5].y = 200 - points23[11] * 200;
        pnt[6].x = points23[12] * 200; pnt[6].y = 200 - points23[13] * 200;
        pnt[7].x = points23[14] * 200; pnt[7].y = 200 - points23[15] * 200;
        pnt[8].x = points23[16] * 200; pnt[8].y = 200 - points23[17] * 200;
        pnt[9].x = points23[18] * 200; pnt[9].y = 200 - points23[19] * 200;
        pnt[10].x = points23[20] * 200; pnt[10].y = 200 - points23[21] * 200;
        pnt[11].x = points23[22] * 200; pnt[11].y = 200 - points23[23] * 200;
        pnt[12].x = points23[24] * 200; pnt[12].y = 200 - points23[25] * 200;
        pnt[13].x = points23[26] * 200; pnt[13].y = 200 - points23[27] * 200;
        pnt[14].x = points23[28] * 200; pnt[14].y = 200 - points23[29] * 200;
        pnt[15].x = points23[30] * 200; pnt[15].y = 200 - points23[31] * 200;
        pnt[16].x = points23[32] * 200; pnt[16].y = 200 - points23[33] * 200;
        pnt[17].x = points23[34] * 200; pnt[17].y = 200 - points23[35] * 200;
        pnt[18].x = points23[36] * 200; pnt[18].y = 200 - points23[37] * 200;
        pnt[19].x = points23[38] * 200; pnt[19].y = 200 - points23[39] * 200;
        XFillPolygon( display, pixmap, gc, pnt, 20, Convex, CoordModeOrigin );

        XSetForeground( display, gc, AllocColor( display, colormap, "white" ) );
        pnt[0].x = monitor[0] * 200; pnt[0].y = 200 - monitor[1] * 200;
        pnt[1].x = monitor[2] * 200; pnt[1].y = 200 - monitor[3] * 200;
        pnt[2].x = monitor[4] * 200; pnt[2].y = 200 - monitor[5] * 200;
        pnt[3].x = monitor[6] * 200; pnt[3].y = 200 - monitor[7] * 200;
        XDrawLines( display, pixmap, gc, pnt, 4, CoordModeOrigin );

        XSetForeground( display, gc, AllocColor( display, colormap, "black" ) );
        XCopyArea( display, pixmap, window, gc, 0, 0, 200, 200, 0, 0 );
    }
    else {

        unsigned int     facetAttributes = PEXGANone;
        unsigned int     vertexAttributes = PEXGAColor;
        int              colorType = PEXColorTypeRGB;
        PEXArrayOfVertex pointsData;

        PEXSetInteriorStyle( display, resource_id, dest,
            PEXInteriorStyleSolid );
        PEXSetSurfaceInterpMethod( display, resource_id, dest,
            PEXSurfaceInterpColor );

        PEXSetLineColorIndex( display, resource_id, dest, 23 );
        PEXPolyline2D( display, resource_id, dest, 2, (PEXCoord2D *)xaxis );
        PEXPolyline2D( display, resource_id, dest, 2, (PEXCoord2D *)xtick8 );
        PEXPolyline2D( display, resource_id, dest, 2, (PEXCoord2D *)xtick7 );
        PEXPolyline2D( display, resource_id, dest, 2, (PEXCoord2D *)xtick6 );
        PEXPolyline2D( display, resource_id, dest, 2, (PEXCoord2D *)xtick5 );
        PEXPolyline2D( display, resource_id, dest, 2, (PEXCoord2D *)xtick4 );
        PEXPolyline2D( display, resource_id, dest, 2, (PEXCoord2D *)xtick3 );
        PEXPolyline2D( display, resource_id, dest, 2, (PEXCoord2D *)xtick2 );
        PEXPolyline2D( display, resource_id, dest, 2, (PEXCoord2D *)xtick1 );
    
        PEXPolyline2D( display, resource_id, dest, 2, (PEXCoord2D *)yaxis );
        PEXPolyline2D( display, resource_id, dest, 2, (PEXCoord2D *)ytick8 );
        PEXPolyline2D( display, resource_id, dest, 2, (PEXCoord2D *)ytick7 );
        PEXPolyline2D( display, resource_id, dest, 2, (PEXCoord2D *)ytick6 );
        PEXPolyline2D( display, resource_id, dest, 2, (PEXCoord2D *)ytick5 );
        PEXPolyline2D( display, resource_id, dest, 2, (PEXCoord2D *)ytick4 );
        PEXPolyline2D( display, resource_id, dest, 2, (PEXCoord2D *)ytick3 );
        PEXPolyline2D( display, resource_id, dest, 2, (PEXCoord2D *)ytick2 );
        PEXPolyline2D( display, resource_id, dest, 2, (PEXCoord2D *)ytick1 );

        pointsData.rgb = pointsWithData1;
        PEXFillAreaWithData( display, resource_id, dest, PEXShapeConvex, True,
            facetAttributes, vertexAttributes, colorType,
            ( PEXFacetData *)NULL, 4, pointsData );
        pointsData.rgb = pointsWithData2;
        PEXFillAreaWithData( display, resource_id, dest, PEXShapeConvex, True,
            facetAttributes, vertexAttributes, colorType,
            ( PEXFacetData *)NULL, 4, pointsData );
        pointsData.rgb = pointsWithData3;
        PEXFillAreaWithData( display, resource_id, dest, PEXShapeConvex, True,
            facetAttributes, vertexAttributes, colorType,
            ( PEXFacetData *)NULL, 4, pointsData );
        pointsData.rgb = pointsWithData4;
        PEXFillAreaWithData( display, resource_id, dest, PEXShapeConvex, True,
            facetAttributes, vertexAttributes, colorType,
            ( PEXFacetData *)NULL, 4, pointsData );
        pointsData.rgb = pointsWithData5;
        PEXFillAreaWithData( display, resource_id, dest, PEXShapeConvex, True,
            facetAttributes, vertexAttributes, colorType,
            ( PEXFacetData *)NULL, 4, pointsData );
        pointsData.rgb = pointsWithData6;
        PEXFillAreaWithData( display, resource_id, dest, PEXShapeConvex, True,
            facetAttributes, vertexAttributes, colorType,
            ( PEXFacetData *)NULL, 4, pointsData );
        pointsData.rgb = pointsWithData7;
        PEXFillAreaWithData( display, resource_id, dest, PEXShapeConvex, True,
            facetAttributes, vertexAttributes, colorType,
            ( PEXFacetData *)NULL, 4, pointsData );
        pointsData.rgb = pointsWithData8;
        PEXFillAreaWithData( display, resource_id, dest, PEXShapeConvex, True,
            facetAttributes, vertexAttributes, colorType,
            ( PEXFacetData *)NULL, 4, pointsData );
        pointsData.rgb = pointsWithData9;
        PEXFillAreaWithData( display, resource_id, dest, PEXShapeConvex, True,
            facetAttributes, vertexAttributes, colorType,
            ( PEXFacetData *)NULL, 10, pointsData );
        pointsData.rgb = pointsWithData10;
        PEXFillAreaWithData( display, resource_id, dest, PEXShapeConvex, True,
            facetAttributes, vertexAttributes, colorType,
            ( PEXFacetData *)NULL, 4, pointsData );
        pointsData.rgb = pointsWithData11;
        PEXFillAreaWithData( display, resource_id, dest, PEXShapeConvex, True,
            facetAttributes, vertexAttributes, colorType,
            ( PEXFacetData *)NULL, 4, pointsData );
        pointsData.rgb = pointsWithData12;
        PEXFillAreaWithData( display, resource_id, dest, PEXShapeConvex, True,
            facetAttributes, vertexAttributes, colorType,
            ( PEXFacetData *)NULL, 4, pointsData );
        pointsData.rgb = pointsWithData13;
        PEXFillAreaWithData( display, resource_id, dest, PEXShapeConvex, True,
            facetAttributes, vertexAttributes, colorType,
            ( PEXFacetData *)NULL, 4, pointsData );
        pointsData.rgb = pointsWithData14;
        PEXFillAreaWithData( display, resource_id, dest, PEXShapeConvex, True,
            facetAttributes, vertexAttributes, colorType,
            ( PEXFacetData *)NULL, 4, pointsData );
        pointsData.rgb = pointsWithData15;
        PEXFillAreaWithData( display, resource_id, dest, PEXShapeConvex, True,
            facetAttributes, vertexAttributes, colorType,
            ( PEXFacetData *)NULL, 6, pointsData );
        pointsData.rgb = pointsWithData16;
        PEXFillAreaWithData( display, resource_id, dest, PEXShapeConvex, True,
            facetAttributes, vertexAttributes, colorType,
            ( PEXFacetData *)NULL, 4, pointsData );
        pointsData.rgb = pointsWithData17;
        PEXFillAreaWithData( display, resource_id, dest, PEXShapeConvex, True,
            facetAttributes, vertexAttributes, colorType,
            ( PEXFacetData *)NULL, 5, pointsData );
        pointsData.rgb = pointsWithData18;
        PEXFillAreaWithData( display, resource_id, dest, PEXShapeConvex, True,
            facetAttributes, vertexAttributes, colorType,
            ( PEXFacetData *)NULL, 4, pointsData );
        pointsData.rgb = pointsWithData19;
        PEXFillAreaWithData( display, resource_id, dest, PEXShapeConvex, True,
            facetAttributes, vertexAttributes, colorType,
            ( PEXFacetData *)NULL, 4, pointsData );
        pointsData.rgb = pointsWithData20;
        PEXFillAreaWithData( display, resource_id, dest, PEXShapeConvex, True,
            facetAttributes, vertexAttributes, colorType,
            ( PEXFacetData *)NULL, 4, pointsData );
        pointsData.rgb = pointsWithData21;
        PEXFillAreaWithData( display, resource_id, dest, PEXShapeConvex, True,
            facetAttributes, vertexAttributes, colorType,
            ( PEXFacetData *)NULL, 4, pointsData );
        pointsData.rgb = pointsWithData22;
        PEXFillAreaWithData( display, resource_id, dest, PEXShapeConvex, True,
            facetAttributes, vertexAttributes, colorType,
            ( PEXFacetData *)NULL, 4, pointsData );
        pointsData.rgb = pointsWithData23;
        PEXFillAreaWithData( display, resource_id, dest, PEXShapeConvex, True,
            facetAttributes, vertexAttributes, colorType,
            ( PEXFacetData *)NULL, 20, pointsData );

        PEXSetLineColorIndex( display, resource_id, dest, 23 );
        PEXPolyline2D( display, resource_id, dest, 4, (PEXCoord2D *)monitor );

        PEXLabel( display, resource_id, dest, 1 );
        /* dummy element in structure */
        PEXApplicationData( display, resource_id, dest, 0, (char*)NULL );

        PEXRenderNetwork( display, window, rd, sid );
        XFlush( display );
    }
}
