
#ifndef _globals_h
#define _globals_h

#include "xpex.h"

#define VRP_X	01
#define VRP_Y	02
#define VRP_Z	03
#define VRP_ALL	04

#define VUP_X	11
#define VUP_Y	12
#define VUP_Z	13
#define VUP_ALL	14

#define VPN_X	21
#define VPN_Y	22
#define VPN_Z	23
#define VPN_ALL	24

#define PRP_X	31
#define PRP_Y	32
#define PRP_Z	33
#define PRP_ALL	34

#define BACK	41
#define VIEW	42
#define FRONT	43

#define WIN_LL	51
#define WIN_UR	52

#define NPC_MIN_X	61
#define NPC_MIN_Y	62
#define NPC_MIN_Z	63

#define NPC_MAX_X	71
#define NPC_MAX_Y	72
#define NPC_MAX_Z	73

extern Display *dpy;
extern Window   window;
extern Colormap colormap;
extern GC       gc;
extern Atom     delete_window_atom;
extern Widget   toplevel, canvas, canvasWindow;

extern PEXRenderer           renderer;
extern PEXRendererAttributes rattrs;

extern PEXStructure top_struct, plane, sphere;

extern PEXColorSpecifier colorSpec;

/* The viewing parameters. */
extern PEXCoord         view_ref_pt;
extern PEXVector        view_up_vec;
extern PEXVector        view_plane_normal;
extern PEXCoord2D       view_window[2];
extern PEXNPCSubVolume  viewport;
extern double           view_plane, front_plane, back_plane;
extern PEXCoord         proj_ref_pt;
extern int              perspective;
extern PEXViewEntry     view;

#endif /* _globals_h */
